'use strict';

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _bodyParser = require('body-parser');

var _bodyParser2 = _interopRequireDefault(_bodyParser);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const InternalServer = (serviceManager, validateService, port) => {
  const start = () => new Promise(resolve => {
    const app = (0, _express2.default)();
    app.use(_bodyParser2.default.json());

    app.post('/:service/:message/:key', async (req, res) => {
      try {
        if (validateService(req.params.key)) {
          const response = await serviceManager.sendMessage(req.params.service, req.params.message, req.body);
          res.json({
            success: true,
            response
          });
        } else {
          res.status(403).json({
            success: false,
            error: '🖕'
          });
        }
      } catch (error) {
        console.error(error.stack || error);
        res.status(500).json({
          success: false,
          error
        });
      }
    });

    app.listen(port, () => {
      resolve();
    });
  });

  return {
    start
  };
};

module.exports = InternalServer;