'use strict';

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _bodyParser = require('body-parser');

var _bodyParser2 = _interopRequireDefault(_bodyParser);

var _cookieParser = require('cookie-parser');

var _cookieParser2 = _interopRequireDefault(_cookieParser);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const Server = (serviceManager, port, key) => {
  const start = () => new Promise(resolve => {
    const app = (0, _express2.default)();
    app.use(_bodyParser2.default.json());
    app.use((0, _cookieParser2.default)());

    app.get('/login/:key', (req, res) => {
      res.cookie('key', req.params.key);
      res.send('👋');
    });

    const handler = async (req, res, requestKey) => {
      try {
        if (requestKey === key) {
          const response = await serviceManager.sendMessage(req.params.service, req.params.message, req.body);
          res.json({
            success: true,
            response
          });
        } else {
          res.status(403).json({
            success: false,
            error: '🖕'
          });
        }
      } catch (error) {
        console.error(error.stack || error);
        res.status(500).json({
          success: false,
          error
        });
      }
    };

    app.get('/:service/:message/:key', (req, res) => handler(req, res, req.params.key));
    app.get('/:service/:message', (req, res) => handler(req, res, req.cookies.key));
    app.post('/:service/:message/:key', (req, res) => handler(req, res, req.params.key));
    app.post('/:service/:message', (req, res) => handler(req, res, req.cookies.key));

    app.listen(port, () => {
      console.log(`Colosseum is running at http://localhost:${port} with key ${key}`);
      resolve();
    });
  });

  return {
    start
  };
};

module.exports = Server;