'use strict';

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _Server = require('./Server');

var _Server2 = _interopRequireDefault(_Server);

var _ServiceManager = require('./ServiceManager');

var _ServiceManager2 = _interopRequireDefault(_ServiceManager);

var _key = require('../util/key');

var _key2 = _interopRequireDefault(_key);

var _args = require('../util/args');

var _args2 = _interopRequireDefault(_args);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const DEFAULT_PORT = 8080;
const DEFAULT_SERVICES_PATH = _path2.default.join(__dirname, '../../services');
const DEFAULT_STORE_PATH = _path2.default.join(__dirname, '../../data');

const start = async () => {
  try {
    const { key, port, services, store } = (0, _args2.default)({
      port: DEFAULT_PORT,
      key: await (0, _key2.default)(),
      services: DEFAULT_SERVICES_PATH,
      store: DEFAULT_STORE_PATH
    });

    const portNumber = Number(port);

    const serviceManager = (0, _ServiceManager2.default)(services, store, portNumber + 1);
    await serviceManager.initialise();

    const server = (0, _Server2.default)(serviceManager, portNumber, key);
    await server.start();
  } catch (error) {
    console.error(error);
  }
};

start();