'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.init = exports.uninstall = exports.install = undefined;

var _process = require('./process');

const install = (url, directory) => (0, _process.run)(`npm install ${url} --production`, directory);

const uninstall = (name, directory) => (0, _process.run)(`npm uninstall ${name}`, directory);

const init = directory => (0, _process.run)('npm init -y', directory);

exports.install = install;
exports.uninstall = uninstall;
exports.init = init;